﻿
import algo.all;
import basic.all;
import std.string;
private import main_bn;
import std.stdio;
import std.file;
import std.math : abs;



int main()
{
	try {
		log("B/N: " ~ .toString(main_bn.auto_build_number));
		return boot();
	}
	catch (Object o) {
		log("[" ~ o.classinfo.name ~ "] " ~ o.toString());
		return 1;
	}
}

extern (Windows) int MessageBoxW( void* hWnd, wchar* pszText, wchar* pszCaption, uint uType );

int boot()
{
	bool fullscreen;
	if (MessageBoxW(null, "フルスクリーンで起動しますか？"w.ptr, "どうする！？"w.ptr, 4) == 6)
		fullscreen = true;
	
	Display.set(512, 512, 16, fullscreen);
	setFPS(60);
	Audio.open();

	se["dos"] = new Sound("data/dos.wav");
	se["getstar"] = new Sound("data/getstar.wav");
	se["hukkatsu"] = new Sound("data/hukkatsu.wav");
	se["select"] = new Sound("data/select.wav");
	se["sibo"] = new Sound("data/sibo.wav");
	
	SceneControl.start(SceneStart);
	
	while (EventControl.update()) {
		SceneControl.move();
		if (delayFPS()) {
			SceneControl.draw();
			debug Display.string(0, 0, .toString(getFPS()), 128, 128, 128, 255);
			Display.update();
		}
	}
	
	return 0;
}

class SceneStart_ : Scene
{
	mixin Singleton;

	Texture logo;
	
	void start( Elements e ) {
		logo = new Texture("data/logo.bmp");
	}

	void end() {
		
	}

	void move() {
		if (EasyInput[0] == 1)
			select--, se["select"].play();
		if (EasyInput[2] == 1)
			select++, se["select"].play();
		
		if (select >= 2) select -= 2;
		if (select <  0) select += 2;
		
		if (EasyInput[4] == 1) {
			switch (select) {
			case 0:
				se["select"].play();
				Elements e;
				e["map"] = pack(1);
				e["time"] = pack(1);
				SceneControl.next(SceneGame, e);
				break;
				
			case 1:
				se["select"].play();
				EventControl.pushQuitEvent();
				break;
			}
		}
	}

	void draw() {
		Display.clear(255,255,255);
		
		logo.blit(null, Display, 180, 180);
		
		Display.string(220,300,"HAZIMEKARA",0,0,0,(select==0)?255:64);
		Display.string(220,316,"OWAREXIT"  ,0,0,0,(select==1)?255:64);
	}

	int select;
}
alias SceneStart_.instance SceneStart;

class SceneClear_ : Scene
{
	mixin Singleton;

	Texture otu;
	Texture[char] font;
	Texture[5] rank;
	Texture resbmp, resbmp2;
	char[] timestr;
	real time;
	Vector2D timepoint;
	int f;
	
	void start( Elements e ) {
		otu = new Texture("data/otu.bmp");
		foreach (c; "0123456789.") {
			font[c] = new Texture("data/" ~ c ~ ".bmp");
			font[c].setColorKey();
		}
		resbmp  = new Texture("data/result.bmp");
		resbmp2 = new Texture("data/result2.bmp");
		resbmp.setColorKey();
		resbmp2.setColorKey();

		for (int i; i<5; i++)
			rank[i] = new Texture("data/rank" ~ .toString(i+1) ~ ".bmp");
		
		int frame = unpack!(int)(e["time"]);
		timestr = format("%.2f", cast(float)(1.0/60.0 * frame));
		time = 1.0/60.0 * frame;
	}

	void end() {
		Audio.stop();
	}

	void move() {
		f++;
		
		if (EasyInput[4] == 1) {
			SceneControl.start(SceneStart);
		}
	}
	

	void draw() {
		Display.clear(255,255,255);
		
		otu.blit(null, Display, 200, 64);
		
		resbmp.blit(null, Display, 150, 150);
		
		foreach (i, c; timestr) {
			Vector2D v;
			int n = f*3 + i*20;
			v.pow = abs(n/20%60-30);
			v.dir = rad(n);
			font[c].blit(null, Display, 80+48*i+cast(int)v.x, 260+cast(int)v.y);
		}
		
		resbmp2.blit(null, Display, 400, 290);
		
		int ranknum;
		if (time > 400)       ranknum = 0;
		else if (time > 300) ranknum = 1;
		else if (time > 200) ranknum = 2;
		else if (time > 150) ranknum = 3;
		else                 ranknum = 4;
		rank[ranknum].blit(null, Display, 180, 400);
		
	}

	int select;
}
alias SceneClear_.instance SceneClear;


class SceneGameOver_ : Scene
{
	mixin Singleton;

	Texture go;
	Texture ss;
	Vector2D kanban, kanbanspeed;
	
	void start( Elements e ) {
		Audio.stop();
		go = new Texture("data/gameover.bmp");
		ss = new Texture(512, 512);
		Display.blit(null, ss, 0, 0);
		kanbanspeed.x = 0;
		kanbanspeed.y = 1;
		kanban.x = 0;
		kanban.y = -512;
	}

	void end() {
		
	}

	void move() {
		kanbanspeed.y += 1;
		
		kanban += kanbanspeed;
		if (kanban.y > 0) {
			kanban.y = 0;
			kanbanspeed.y *= -0.7;
			if (kanbanspeed.y > -1)
				kanbanspeed.y = 0;
			else
				se["dos"].play();
		}
		
		if (EasyInput[4] == 1) {
			SceneControl.start(SceneStart);
		}
	}
	

	void draw() {
		ss.blit(null, Display, 0, 0);
		
		int x = cast(int)kanban.x;
		int y = cast(int)kanban.y;
		
		Display.rect(0,0,512,y+512, 0,0,0,255, true);
		go.blit(null, Display, (512-423)/2, y+230);
	}
}
alias SceneGameOver_.instance SceneGameOver;


Texture charabmp;
Texture mapbmp;

Sound[char[]] se;

static this() {
	mapbmp = new Texture("data/map.bmp");
	charabmp = new Texture("data/chara.bmp");
	mapbmp.setColorKey();
	charabmp.setColorKey();
}

class SceneGame_ : Scene
{
	mixin Singleton;

	Texture clear;
	ubyte[32][32] map;
	int rest;

	int tmap;
	int sframe;

	void start( Elements e ) {
		Rabbit.clear();
		DeadRabbit.clear();
		LifeBall.clear();

		clear = new Texture("data/clear.bmp");
		clear.setColorKey();
		
		tmap = unpack!(int)(e["map"]);
		sframe = unpack!(int)(e["time"]);
		Texture bmp = new Texture("data/map" ~ .toString(tmap) ~ ".bmp");

		if (tmap < 5)
			(new Music("data/jump.ogg")).playLoop();
		else
			(new Music("data/jump2.ogg")).playLoop();
		
		int sx, sy;
		rest = 0;
		for (int y; y<32; y++)
			for (int x; x<32; x++) {
				map[x][y] = (cast(ubyte*)bmp.entity.pixels)[y*32 + x];
				if (map[x][y] == 3) rest++;
				if (map[x][y] == 15) sx = x*15, sy = y*15;
			}
		
		Elements el;
		el["color"] = pack(0);
		el["left"] = pack(false);
		el["map"] = pack(map);
		el["rest"] = pack(rest);
		el["x"] = pack(sx);
		el["y"] = pack(sy);
		el["sx"] = pack(0);
		el["sy"] = pack(0);
		LifeBall.birth(el);
	}

	void end() {
		
	}

	void move() {
		sframe++;
		
		if (rest <= 0 && rest > -60) {
			for (int y; y<32; y++)
				for (int x; x<32; x++) {
					if (map[x][y] == 4 || map[x][y] == 5) map[x][y] = 0;
				}
			rest--;
		}
		else if (rest <= 0) {
			if (!exists("data/map" ~ .toString(tmap+1) ~ ".bmp")) {
				Elements e;
				e["time"] = pack(sframe);
				SceneControl.change(SceneClear, e);
				return;
			}
			Elements e;
			e["map"] = pack(tmap+1);
			e["time"] = pack(sframe);
			SceneControl.change(SceneGame, e);
			return;
		}
		Rabbit.moveAll();
		DeadRabbit.moveAll();
		LifeBall.moveAll();
	}

	void draw() {
		Display.clear(255,255,255);
		
		Rect rc;
		rc.w = 16;
		rc.h = 16;
		for (int y; y<32; y++) {
			for (int x; x<32; x++) {
				rc.x = map[x][y] % 4 * 16;
				rc.y = map[x][y] / 4 * 16;
				mapbmp.blit(&rc, Display, x*15+16, y*15+16);
				//Display.string(x*16,y*16,.toString(map[x][y]),0,0,0,255);
			}
		}
		
		DeadRabbit.drawAll();
		Rabbit.drawAll();
		LifeBall.drawAll();
		//Display.string(224,252,"rest: " ~ .toString(rest), 0,0,0,255);

		if (rest < 0) {
			int n = 256 / -rest;
			Display.rect(0,0,512,260-n,0,0,0,255,true);
			Display.rect(0,252+n,512,512,0,0,0,255,true);
			clear.blit(null, Display, 256-139, 220);
		}

		Display.string(400,8,format("Time: %.02f",cast(float)((1.0/60.0)*sframe)),0,0,0,255);
	}
}
alias SceneGame_.instance SceneGame;



class LifeBall : Actor
{
	mixin ActorFuncs;

	Vector2D point;
	Vector2D[5] rollingstars;
	int frame;
	
	void move() {
		frame--;
		for (int i; i<5; i++) {
			rollingstars[i].roll(30);
			rollingstars[i].pow = rollingstars[i].pow - 1;
		}
		
		if (frame == 10)
			Rabbit.birth(pe);
		
		if (frame == 0)
			die();
	}

	void draw() {
		short x = cast(int)point.x;
		int y = cast(int)point.y;
		Display.circle(x, y, 8, 8, 255,64,64, frame*4,true);
		
		for (int i; i<5; i++) {
			Vector2D tv = point;
			tv += rollingstars[i];
			x = cast(int)tv.x;
			y = cast(int)tv.y;
			Display.circle(x, y, 4, 4, 255,255,0,frame*2+120,true);
		}

		Rect rc;
		rc.w = rc.h = 16;
		rc.x = 16;
		for (int i=unpack!(int)(pe["color"])+1; i<3; i++) {
			rc.y = i*32;
			charabmp.blit(&rc, Display, 32+i*24, 0);
		}
	}

	void dead() {
		
	}

	void born( Elements e ) {
		se["hukkatsu"].play();
		frame = 60;
		pe = e;
		point.x = unpack!(int)(e["x"]) + 24;
		point.y = unpack!(int)(e["y"]) + 24;
		for (int i; i<5; i++) {
			rollingstars[i].x = 60;
			rollingstars[i].y = 0;
			rollingstars[i].dir = rad(360/5 * i);
		}
	}

	Elements pe;
}


class Rabbit : Actor
{
	mixin ActorFuncs;

	int color;
	Vector2D point, speed;
	bool leftmuki;
	bool ground;
	ubyte[32][] map;
	

	void move() {
		if (EasyInput[1] > 0)
			speed.x += 0.10, leftmuki = false;
		if (EasyInput[3] > 0)
			speed.x -= 0.10, leftmuki = true;
		if (EasyInput[5] == 1 && ground)
			speed.y = -5;
		
		speed.y += 0.2;
		if (speed.x >  2) speed.x =  2;
		if (speed.x < -2) speed.x = -2;
		if (speed.y >  5) speed.y =  5;
		if (speed.y < -5) speed.y = -5;
		
		if (ground && (EasyInput[1]+EasyInput[3] == 0 || EasyInput[1]&&EasyInput[3])) speed.x /= 1.2;
		
		if (speed.y < 0)
			if (EasyInput[5] == 0) speed.y += 0.2;
		
		point += speed;
		
		hitCheck();
	}

	void hitCheck() {
		int x = cast(int)point.x;
		int y = cast(int)point.y;
		
		if (pointToMap(x+7, y+7) == 3) {
			map[(x+7)/15][(y+7)/15] = 0;
			SceneGame.rest--;
			se["getstar"].play();
		}
		
		while (pointToMap(x+7, y+14) == 1 || pointToMap(x+7, y+14) == 4 ||
		        pointToMap(x+7, y+(x-8)%15) == 6 || pointToMap(x+7, y+(-((x-8)%15)+14)) == 7) {
			speed.y = min(0.0L, speed.y);
			point.y -= 1;
			y--;
		}
		
		while (pointToMap(x+7, y+1) == 1 || pointToMap(x+7, y+1) == 4) {
			speed.y = max(0.0L, speed.y);
			point.y += 1;
			y++;
		}
		
		while (pointToMap(x+2, y+7) == 1 || pointToMap(x+2, y+7) == 4) {
			speed.x = max(0.0L, speed.x);
			point.x += 1;
			x++;
		}
		
		while (pointToMap(x+12, y+7) == 1 || pointToMap(x+12, y+7) == 4) {
			speed.x = min(0.0L, speed.x);
			point.x -= 1;
			x--;
		}
		
		if (pointToMap(x+7, y+15) == 1 || pointToMap(x+7, y+15) == 4 ||
		    pointToMap(x+7, y+1+(x-8)%15) == 6 || pointToMap(x+7, y+(-((x-8)%15)+15)) == 7)
			ground = true;
		else
			ground = false;
		
		if (pointToMap(x+7, y+7) == 2 || pointToMap(x+7, y+7) == 5)
			this.die();
	}

	ubyte pointToMap( int x, int y ) {
		return map[x/15][y/15];
	}
	
	void draw() {
		Rect rc;
		rc.w = rc.h = 16;
		rc.x = (max(EasyInput[1], EasyInput[3]) / 4 + 1) % 4 * 16;
		rc.y = leftmuki * 16 + color * 32;
		charabmp.blit(&rc, Display, cast(short)point.x+16, cast(short)point.y+16);

		rc.x = 16;
		for (int i=color+1; i<3; i++) {
			rc.y = i*32;
			charabmp.blit(&rc, Display, 32+i*24, 0);
		}
	}


	int startx, starty;
	bool startleft;
	void born( Elements e ) {
		color = unpack!(int)(e["color"]);
		leftmuki = unpack!(bool)(e["left"]);
		map = unpack!(ubyte[32][])(e["map"]);
		point.x = unpack!(int)(e["x"]);
		point.y = unpack!(int)(e["y"]);
		speed.x = unpack!(int)(e["sx"]);
		speed.y = unpack!(int)(e["sy"]);
		
		startx = cast(int)point.x;
		starty = cast(int)point.y;
		startleft = leftmuki;
	}

	void dead() {
		se["sibo"].play();
		
		Elements e;
		e["color"] = pack(color);
		e["left"] = pack(leftmuki);
		e["map"] = pack(map);
		e["x"] = pack(cast(int)point.x);
		e["y"] = pack(cast(int)point.y);
		e["sx"] = pack(cast(int)speed.x);
		e["sy"] = pack(cast(int)speed.y);
		DeadRabbit.birth(e); // ＾＾；

		if (color == 2) {
			SceneControl.change(SceneGameOver);
			return;
		}
		e["color"] = pack(color+1);
		e["left"] = pack(startleft);
		e["map"] = pack(map);
		e["x"] = pack(startx);
		e["y"] = pack(starty);
		e["sx"] = pack(0);
		e["sy"] = pack(0);
		LifeBall.birth(e);
	}
}



class DeadRabbit : Rabbit
{
	mixin ActorFuncs;
	
	void move() {
		speed.y += 0.2;
		if (speed.x >  2) speed.x =  2;
		if (speed.x < -2) speed.x = -2;
		if (speed.y >  5) speed.y =  5;
		if (speed.y < -5) speed.y = -5;
		
		if (ground) speed /= 1.2;
		
		point += speed;
		
		hitCheck();
	}

	void hitCheck() {
		int x = cast(int)point.x;
		int y = cast(int)point.y;
		
		if (pointToMap(x+7, y+7) == 3) {
			map[(x+7)/15][(y+7)/15] = 0;
			SceneGame.rest--;
		}
		
		while (pointToMap(x+7, y+14) == 1 || pointToMap(x+7, y+14) == 4 ||
		        pointToMap(x+7, y+(x-8)%15) == 6 || pointToMap(x+7, y+(-((x-8)%15)+14)) == 7) {
			speed.y = min(0.0L, speed.y);
			point.y -= 1;
			y--;
		}
		
		while (pointToMap(x+7, y+1) == 1 || pointToMap(x+7, y+1) == 4) {
			speed.y = max(0.0L, speed.y);
			point.y += 1;
			y++;
		}
		
		while (pointToMap(x+2, y+7) == 1 || pointToMap(x+2, y+7) == 4) {
			speed.x = max(0.0L, speed.x);
			point.x += 1;
			x++;
		}
		
		while (pointToMap(x+12, y+7) == 1 || pointToMap(x+12, y+7) == 4) {
			speed.x = min(0.0L, speed.x);
			point.x -= 1;
			x--;
		}
		
		if (pointToMap(x+7, y+15) == 1 || pointToMap(x+7, y+15) == 4 ||
		    pointToMap(x+7, y+1+(x-8)%15) == 6 || pointToMap(x+7, y+(-((x-8)%15)+15)) == 7)
			ground = true;
		else
			ground = false;
	}

	void draw() {
		Rect rc;
		rc.w = rc.h = 16;
		rc.x = 16 * 4;
		rc.y = leftmuki * 16 + color * 32;
		charabmp.blit(&rc, Display, cast(short)point.x+16, cast(short)point.y+16);
	}
}


































